#
# Great General Amped Mod
# CvGreatGeneraEventManager By TheLopez
# Partially derived from 
# CvCustomEventManager by Zuul
#

from CvPythonExtensions import *
import CvUtil

import CvEventManager
import sys
import math
import PyHelpers
import CvMainInterface
import GeneralMoraleUtils
import CvConfigParser

gc = CyGlobalContext()	
objGeneralMorale = GeneralMoraleUtils.GeneralMoraleUtils()

PyPlayer = PyHelpers.PyPlayer
PyGame = PyHelpers.PyGame()

# < Great General Amped Start >

# Change the variable to either enable or disable the exuding of morale from 
# Great Generals.
# Default value is true
g_bGreatGeneralsExudeMorale = true

# < Great General Amped End   >

# globals
###################################################
class CvGreatGeneralEventManager:
	def __init__(self, eventManager):
		# initialize base class

		eventManager.addEventHandler("unitMove", self.onUnitMove)
		eventManager.addEventHandler("greatPersonBorn", self.onGreatPersonBorn)
		eventManager.addEventHandler("unitBuilt", self.onUnitBuilt)
		eventManager.addEventHandler("unitCreated", self.onGreatPersonBorn)
		eventManager.addEventHandler("unitLost", self.onUnitLost)
		eventManager.addEventHandler("unitKilled", self.onUnitLost)
		
		# < Great General Amped Start >
		global g_bGreatGeneralsExudeMorale
		
		config = CvConfigParser.CvConfigParser("Great General Amped Config.ini")

		if(config != None):
			g_bGreatGeneralsExudeMorale = config.getboolean("Great General Amped", "Great Generals Exude Morale", True)
		
		# < Great General Amped End   >
		
		
	# Handles the event where a unit moves in the game.
	def onUnitMove(self, argsList):
		
		objPlot,objUnit = argsList	

		if(g_bGreatGeneralsExudeMorale):
			objGeneralMorale.handleUnitMove(objUnit, objPlot)


	def onGreatPersonBorn(self, argsList):
		objUnit = argsList[0]
		
		# We don't really care about the other pansy great persons
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_GENERAL")):
			return

		if(g_bGreatGeneralsExudeMorale):		
			objGeneralMorale.handleGeneralMove(objUnit)
		
		
	def onUnitBuilt(self, argsList):
		pCity,objUnit = argsList

		# We don't really care about the other pansy great persons
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_GENERAL")):
			return

		if(g_bGreatGeneralsExudeMorale):		
			objGeneralMorale.handleGeneralMove(objUnit)

			
	def onUnitLost(self, argsList):
	
		objUnit = argsList[0]
		objPlayer = PyPlayer(objUnit.getOwner())

		# Return immediately unless they are a great general
		if(objUnit.getUnitType() != gc.getInfoTypeForString("UNIT_GENERAL")):
			return

		#this should only be called if the unit killed was a great general.
		objGeneralMorale.removeAllGeneralPromotions(objUnit)

